/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_ESCROW_PROGRAM_ADDRESS } from '../programs';
import { TSwapConfig, TSwapConfigArgs } from '../types';
export type InitUpdateTswapInstruction<TProgram extends string = typeof TENSOR_ESCROW_PROGRAM_ADDRESS, TAccountTswap extends string | IAccountMeta<string> = string, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountNewOwner extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountTswap extends string ? WritableAccount<TAccountTswap> : TAccountTswap,
    TAccountFeeVault extends string ? ReadonlyAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountNewOwner extends string ? ReadonlySignerAccount<TAccountNewOwner> & IAccountSignerMeta<TAccountNewOwner> : TAccountNewOwner,
    ...TRemainingAccounts
]>;
export type InitUpdateTswapInstructionData = {
    discriminator: ReadonlyUint8Array;
    config: TSwapConfig;
};
export type InitUpdateTswapInstructionDataArgs = {
    config: TSwapConfigArgs;
};
export declare function getInitUpdateTswapInstructionDataEncoder(): Encoder<InitUpdateTswapInstructionDataArgs>;
export declare function getInitUpdateTswapInstructionDataDecoder(): Decoder<InitUpdateTswapInstructionData>;
export declare function getInitUpdateTswapInstructionDataCodec(): Codec<InitUpdateTswapInstructionDataArgs, InitUpdateTswapInstructionData>;
export type InitUpdateTswapAsyncInput<TAccountTswap extends string = string, TAccountFeeVault extends string = string, TAccountCosigner extends string = string, TAccountOwner extends string = string, TAccountSystemProgram extends string = string, TAccountNewOwner extends string = string> = {
    tswap?: Address<TAccountTswap>;
    feeVault: Address<TAccountFeeVault>;
    /** We ask also for a signature just to make sure this wallet can actually sign things */
    cosigner: TransactionSigner<TAccountCosigner>;
    owner: TransactionSigner<TAccountOwner>;
    systemProgram?: Address<TAccountSystemProgram>;
    newOwner: TransactionSigner<TAccountNewOwner>;
    config: InitUpdateTswapInstructionDataArgs['config'];
};
export declare function getInitUpdateTswapInstructionAsync<TAccountTswap extends string, TAccountFeeVault extends string, TAccountCosigner extends string, TAccountOwner extends string, TAccountSystemProgram extends string, TAccountNewOwner extends string>(input: InitUpdateTswapAsyncInput<TAccountTswap, TAccountFeeVault, TAccountCosigner, TAccountOwner, TAccountSystemProgram, TAccountNewOwner>): Promise<InitUpdateTswapInstruction<typeof TENSOR_ESCROW_PROGRAM_ADDRESS, TAccountTswap, TAccountFeeVault, TAccountCosigner, TAccountOwner, TAccountSystemProgram, TAccountNewOwner>>;
export type InitUpdateTswapInput<TAccountTswap extends string = string, TAccountFeeVault extends string = string, TAccountCosigner extends string = string, TAccountOwner extends string = string, TAccountSystemProgram extends string = string, TAccountNewOwner extends string = string> = {
    tswap: Address<TAccountTswap>;
    feeVault: Address<TAccountFeeVault>;
    /** We ask also for a signature just to make sure this wallet can actually sign things */
    cosigner: TransactionSigner<TAccountCosigner>;
    owner: TransactionSigner<TAccountOwner>;
    systemProgram?: Address<TAccountSystemProgram>;
    newOwner: TransactionSigner<TAccountNewOwner>;
    config: InitUpdateTswapInstructionDataArgs['config'];
};
export declare function getInitUpdateTswapInstruction<TAccountTswap extends string, TAccountFeeVault extends string, TAccountCosigner extends string, TAccountOwner extends string, TAccountSystemProgram extends string, TAccountNewOwner extends string>(input: InitUpdateTswapInput<TAccountTswap, TAccountFeeVault, TAccountCosigner, TAccountOwner, TAccountSystemProgram, TAccountNewOwner>): InitUpdateTswapInstruction<typeof TENSOR_ESCROW_PROGRAM_ADDRESS, TAccountTswap, TAccountFeeVault, TAccountCosigner, TAccountOwner, TAccountSystemProgram, TAccountNewOwner>;
export type ParsedInitUpdateTswapInstruction<TProgram extends string = typeof TENSOR_ESCROW_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        tswap: TAccountMetas[0];
        feeVault: TAccountMetas[1];
        /** We ask also for a signature just to make sure this wallet can actually sign things */
        cosigner: TAccountMetas[2];
        owner: TAccountMetas[3];
        systemProgram: TAccountMetas[4];
        newOwner: TAccountMetas[5];
    };
    data: InitUpdateTswapInstructionData;
};
export declare function parseInitUpdateTswapInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedInitUpdateTswapInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=initUpdateTswap.d.ts.map